/*******************************************************************************
* FILE NAME: main.c <VEX VERSION>
*
* DESCRIPTION:
*  This file contains the main program loop.
*
* USAGE:
*  You should not need to modify this file.
*  Note the different loop speed for the two routines:
*     Process_Data_From_Master_uP
*     Process_Data_From_Local_IO
*******************************************************************************/

#include "ifi_aliases.h"
#include "ifi_default.h"
#include "ifi_utilities.h"
#include "user_routines.h"
#include "max7219.h"
 
 
#define ENABLE_AUTONOMOUS_MODE   0
#define PORT_A  0
#define PORT_B	1
#define PORT_C	2
#define PORT_D	3
#define PORT_E	4
#define PORT_F	5
#define PORT_G	6
#define PORT_H	7
#define PORT_J 	8

/*
#define IO1             TRISAbits.TRISA0
#define IO2             TRISAbits.TRISA1
#define IO3             TRISAbits.TRISA2
#define IO4             TRISAbits.TRISA3
#define IO5             TRISAbits.TRISA5
#define IO6             TRISFbits.TRISF0
#define IO7             TRISFbits.TRISF1
#define IO8             TRISFbits.TRISF2
#define IO9             TRISFbits.TRISF3
#define IO10            TRISFbits.TRISF4
#define IO11            TRISFbits.TRISF5
#define IO12            TRISFbits.TRISF6
#define IO13            TRISHbits.TRISH4
#define IO14            TRISHbits.TRISH5
#define IO15            TRISHbits.TRISH6
#define IO16            TRISHbits.TRISH7  

// Aliases used to drive the pins when used as OUTPUTS. 
#define rc_dig_out01    LATAbits.LATA0
#define rc_dig_out02    LATAbits.LATA1
#define rc_dig_out03    LATAbits.LATA2
#define rc_dig_out04    LATAbits.LATA3
#define rc_dig_out05    LATAbits.LATA5
#define rc_dig_out06    LATFbits.LATF0
#define rc_dig_out07    LATFbits.LATF1
#define rc_dig_out08    LATFbits.LATF2
#define rc_dig_out09    LATFbits.LATF3
#define rc_dig_out10    LATFbits.LATF4
#define rc_dig_out11    LATFbits.LATF5
#define rc_dig_out12    LATFbits.LATF6
#define rc_dig_out13    LATHbits.LATH4
#define rc_dig_out14    LATHbits.LATH5
#define rc_dig_out15    LATHbits.LATH6
#define rc_dig_out16    LATHbits.LATH7

 // Hardware interface with the  MAX7219 (using PIC18C452 Pin numbering)

#define DataPin1       PORTFbits.RF3      // Bits are shifted out this pin # to the MAX7219.
#define ClockPin1      PORTFbits.RF4      // Data valid on rising edge of this clock (pin RD5).
#define LoadPin1       PORTFbits.RF5      // This control pin tells the 7219 to transfer data to LEDs.  

#define DataPin0       PORTFbits.RF3        // Bits are shifted out this pin # to the MAX7219.
#define ClockPin0      PORTFbits.RF4        // Data valid on rising edge of this clock (pin RD5).
#define LoadPin0       PORTFbits.RF5        // This control pin tells the 7219 to transfer data to LEDs.
*/

 // Hardware interface with the  MAX7219 (using PIC18C452 Pin numbering)

#define DataPin1       rc_dig_out09      // Bits are shifted out this pin # to the MAX7219.
#define ClockPin1      rc_dig_out10      // Data valid on rising edge of this clock (pin RD5).
#define LoadPin1       rc_dig_out11      // This control pin tells the 7219 to transfer data to LEDs.  

#define DataPin0       rc_dig_out09        // Bits are shifted out this pin # to the MAX7219.
#define ClockPin0      rc_dig_out10        // Data valid on rising edge of this clock (pin RD5).
#define LoadPin0       rc_dig_out11        // This control pin tells the 7219 to transfer data to LEDs.  

tx_data_record txdata;          /* DO NOT CHANGE! */
rx_data_record rxdata;          /* DO NOT CHANGE! */
packed_struct statusflag;       /* DO NOT CHANGE! */
//int Buffer[80];  // Output string buffer

/*******************************************************************************
* FUNCTION NAME: main
* PURPOSE:       Main program function.
* CALLED FROM:   ifi_startup.c
* ARGUMENTS:     none
* RETURNS:       void
* DO NOT DELETE THIS FUNCTION 
*******************************************************************************/
void main (void)
{
	int i,j;

char TestNumber[]   = "1234567890";
char TestNumber0[]  = "0987654321";
char TestNumber1[]  = "3141592632";
char TestNumber2[]  = "2.71828282";
char TestNumber3[]  = "6.23456E28";
char TestNumber4[]  = "-3.14E75";
char TestNumber5[]  = "-2.7815";
char TestNumber6[]  = "14533";
char TestNumberL[]  = "HELP  HELP";
 

#ifdef UNCHANGEABLE_DEFINITION_AREA
  IFI_Initialization ();        /* DO NOT CHANGE! */
#endif

  statusflag.NEW_SPI_DATA = 0;  /* DO NOT CHANGE! */ 
  User_Initialization();        /* You edit this in user_routines.c */

#if ENABLE_AUTONOMOUS_MODE
  txdata.user_cmd = 0x02;       /* Tell master you want to be in auton mode. */
#endif


	
    printf("\r\n MAX7219 LED Controller \r\n"); 

   // Setup timers used for delays and software
	SetupTimers();                                         
                                                         
   // Initialize the MAX7219 Numeric LED Display
   InitializeMAX7219();
  
   // Display the value of PI	
 	LED_Print(TestNumber1);
   
   
   while(1);


   while(1)
   {
      for (i=0; i<99999; i++)
      {
 	
        // Convert the integer i to an ASCII string
        itoa(i, TestNumber);									
 		LED_Print(TestNumber);

        // Wait 10 milliseconds
   		pause(10);
   	  }
	}     
   

	 while (1)   // Forever
  	{
 		// Run MAX7219 LED Tests
    	LED_Print(TestNumber);
		pause(5000);	  
  		//LED_Print(TestNumber0);
		//pause(5000);	
 		LED_Print(TestNumber1);
		pause(5000);	
/*  	
    	LED_Print(TestNumber2);
		pause(5000);

  		LED_Print(TestNumber3);
		pause(5000);
  		LED_Print(TestNumber4);
		pause(5000);
  		LED_Print(TestNumber5);
		pause(5000);
  		LED_Print(TestNumber6);
		pause(5000);
		LED_Print(TestNumberL);
		pause(5000);
*/
	}

/*
	// Test the LEDs 
    while (1)
	{

    	DataPin0   = 1;         // Bits are shifted out this pin # to the MAX7219.
  		ClockPin0  = 1;         // Data valid on rising edge of this clock (pin RD5).
  		LoadPin0   = 1;         // This control pin tells the 7219 to transfer data to LEDs.  
   
        pause(1000);

  		DataPin0   = 0;         // Bits are shifted out this pin # to the MAX7219.
  		ClockPin0  = 0;         // Data valid on rising edge of this clock (pin RD5).
  		LoadPin0   = 0;         // This control pin tells the 7219 to transfer data to LEDs.  
   
        pause(1000);

 
	}
*/

/*

	// Test the LEDs 
    while (1)
	{
		for (i=0; i<256; i++)
		{
			PORTA = i;
			pause(1000);
		}
	}
	while(1)
	{
      	for (j=0; j<4; j++)
		{
		 
  			SetBit((byte *)&PORTA, j);
        	pause(1000);
		}
   
 
	}



     	ClearBit((byte *)&PORTD,  BIT_0); 
       	ClearBit((byte *)&PORTD,  BIT_1); 
       	ClearBit((byte *)&PORTD,  BIT_2); 

      	Bit0 = GetBit((byte *)&PORTD,  BIT_0); 
       	Bit1 = GetBit((byte *)&PORTD,  BIT_1); 
       	Bit2 = GetBit((byte *)&PORTD,  BIT_2); 

       	ComplementBit((byte *)&PORTD,  BIT_0); 
       	ComplementBit((byte *)&PORTD,  BIT_1); 
       	ComplementBit((byte *)&PORTD,  BIT_2); 
*/

 

/*  
	 while (1)   // Forever
  	{
 		for (i=0; i<255; i++)
		{
			lcd_goto(0,1);
			printf("Testing %d times!!!\n", i);
			 
			
		}
    }
*/

/*

	while (1)   // Forever
  	{
 		// Run LCD Tests
        WriteLCD('H');
        WriteLCD('e');
        WriteLCD('l');
        WriteLCD('l');
        WriteLCD('o');
        WriteLCD(' ');
        WriteLCD('W ');
        WriteLCD('o ');
        WriteLCD('r ');
        WriteLCD('l ');
        WriteLCD('d ');

 	// Wait 1 second between words for pacing

  	pause(1000);  
  }

*/
		
 /* 
 	// Test the LEDs 
    while (1)
	{
		for (i=0; i<256; i++)
		{
			PORTA = i;
			pause(1000);
		}
	}

*/

/*
 	//while (1)   // Forever
  	//{
 		// Run LCD Tests
        lcd_putc('A');
        lcd_putc('B');
        lcd_putc('C');
        lcd_putc('D');
        lcd_putc('E');
        lcd_putc('F');

   		//lcd_test_1();
   		//lcd_test_2();
   		//lcd_test_3();
   		//lcd_test_4();
	//}
  
*/

  while (1)   /* This loop will repeat indefinitely. */
  {
 
  } /* while (1) */

}  /* END of Main */


/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
